#include <inttypes.h>
#include <stdio.h>

uint16_t
mul(register uint16_t a, register uint16_t b)
{

uint16_t retval;

asm volatile ("andl $0xffff, %%eax;                         \n\t \
               andl $0xffff, %%ecx;                         \n\t \
                                                           \n\t \
               movl $1, %%edx;                         \n\t \
               subl %%eax, %%edx;                         \n\t \
               subl %%ecx, %%edx;                         \n\t \
                                                        \n\t \
               pushl %%edx;                         \n\t \
                                                   \n\t \
               mull %%ecx;                         \n\t \
                                                  \n\t \
               movl %%eax, %%ecx;                         \n\t \
               andl $0xffff, %%ecx;                         \n\t \
                                                           \n\t \
               movl %%eax, %%edx;                         \n\t \
               shrl $16, %%edx;                         \n\t \
                                                       \n\t \
               subw %%dx, %%cx;                         \n\t \
               setc %%dl;                         \n\t \
               andl $0xff, %%edx;                         \n\t \
               addw %%cx, %%dx;                         \n\t \
                                                      \n\t \
               cmpl $0, %%eax;                         \n\t \
               setne %%al;                         \n\t \
               andl $0xff, %%eax;                         \n\t \
               negl %%eax;                         \n\t \
                                                  \n\t \
               andw %%ax, %%dx;                         \n\t \
               notl %%eax;                         \n\t \
               popl %%ecx;                         \n\t \
               andw %%ax, %%cx;                         \n\t \
               orw %%cx, %%dx;"
              : "=d"(retval)
              : "a"(a), "c"(b)
              : "cc"
             );

return retval;
}

