/**
 * A BadInsnException is thrown when the given string array does not
 * parse into an instruction that is understood.  This may be because
 * we have the wrong number of parameters, we don't understand the
 * opcode, or one of the operands doesn't parse.
 */
public class BadInsnException extends Exception {
    public BadInsnException(String why) {
	super(why);
    }

    public BadInsnException(int line, String why) {
	super(line + ": " + why);
    }
}
