/**
 * Infrastructure for a debugging mechanism that can be turned on and
 * off at runtime.
 */
public class Debug {
    private static int verbosity = 1;

    static void setDebug(int d) {
	verbosity = d;
    }

    static int getDebug() {
	return verbosity;
    }

    static public void println(String s) {
	println(2, s);
    }

    static public void println(int level, String s) {
	if (verbosity >= level)
	    System.err.println(s);
    }

}
